---
title: Save-Data
slug: Web/HTTP/Headers/Save-Data
tags:
  - HTTP
  - HTTP Header
  - Reference
  - Request header
  - Save-Data
  - header
---
<p>{{HTTPSidebar}}</p>

<p>The <strong><code>Save-Data</code></strong> header field is a boolean which, in requests, indicates the client's preference for reduced data usage. This could be for reasons such as high transfer costs, slow connection speeds, etc.</p>

<p>A value of <code>On</code> indicates explicit user opt-in into a reduced data usage mode on the client, and when communicated to origins allows them to deliver alternative content to reduce the data downloaded such as smaller image and video resources, different markup and styling, disabled polling and automatic updates, and so on.</p>

<div class="notecard note">
<p><strong>Note</strong>: Disabling HTTP/2 Server Push ({{RFC("7540", "Server Push", "8.2")}}) might be desirable too for reducing data downloads.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">Save-Data: &lt;sd-token&gt;</pre>

<h2 id="Directives">Directives</h2>

<dl>
 <dt><code>&lt;sd-token&gt;</code></dt>
 <dd>A numerical value indicating whether the client wants to opt in to reduced data usage mode. <code>on</code> indicates yes, while <code>off</code> (the default) indicates no.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>The {{HTTPHeader("Vary")}} header ensures that the content is cached properly (for instance ensuring that the user is not served a lower-quality image from the cache when <code>Save-Data</code> header is no longer present [<em>e.g.</em> after having switched from cellular to Wi-Fi]).</p>

<h3 id="With_Save-Data_on">With <code>Save-Data: on</code></h3>

<p>Request:</p>

<pre>GET /image.jpg HTTP/1.0
Host: example.com
Save-Data: on</pre>

<p>Response:</p>

<pre>HTTP/1.0 200 OK
Content-Length: 102832
Vary: Accept-Encoding, Save-Data
Cache-Control: public, max-age=31536000
Content-Type: image/jpeg

[...]
</pre>

<h3 id="Without_Save-Data">Without <code>Save-Data</code></h3>

<p>Request:</p>

<pre>GET /image.jpg HTTP/1.0
Host: example.com
</pre>

<p>Response:</p>

<pre>HTTP/1.0 200 OK
Content-Length: 481770
Vary: Accept-Encoding, Save-Data
Cache-Control: public, max-age=31536000
Content-Type: image/jpeg

[...]
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Title</th>
  </tr>
  <tr>
   <td><a href="https://tools.ietf.org/html/draft-grigorik-http-client-hints-03#section-7">draft-grigorik-http-client-hints-03, section 7: Save-Data</a></td>
   <td>HTTP Client Hints</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("http.headers.Save-Data")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://css-tricks.com/help-users-save-data/">Help Your Users `Save-Data` - CSS Tricks</a></li>
 <li><a href="https://developers.google.com/web/fundamentals/performance/optimizing-content-efficiency/save-data/">Delivering Fast and Light Applications with Save-Data - Google Developers</a></li>
 <li>Header to indicate that the content served varies by <code>Save-Data</code>: {{HTTPHeader("Vary")}}</li>
 <li>CSS @media feature <code><a href="/en-US/docs/Web/CSS/@media/prefers-reduced-data">prefers-reduced-data</a></code> {{experimental_inline}}</li>
</ul>
